searchNodes=[{"doc":"Check for updates to nerves_bootstrap Example: mix local . nerves This accepts the same command line options as archive.install .","ref":"Mix.Tasks.Local.Nerves.html","title":"Mix.Tasks.Local.Nerves","type":"task"},{"doc":"Bootstrap Nerves tooling into the current Mix tooling The Nerves lib contains all the tasks and tooling for setting up the environment needed to use the Nerves project. However, some of that tooling needs to be injected early in the build process before everything is compiled. The purpose of this task is to ensure the Nerves integration is compiled first and available to be injected into the Mix tooling since Nerves.Bootstrap is available as an archive. (i.e. this is like having :nerves as a dependency of this archive even though archives do not allow traditional dependencies) It is not intended to be run manually","ref":"Mix.Tasks.Nerves.Bootstrap.html","title":"Mix.Tasks.Nerves.Bootstrap","type":"task"},{"doc":"Creates a new Nerves project mix nerves . new PATH [ -- module MODULE ] [ -- app APP ] [ -- target TARGET ] [ -- cookie STRING ] [ -- no - nerves - pack ] The project will be created at PATH. The application name and module name will be inferred from PATH unless --module or --app is given. An --app option can be given in order to name the OTP application for the project. A --module option can be given in order to name the modules in the generated code skeleton. A --target option can be given to limit support to one or more of the officially Nerves systems . A --cookie options can be given to set the Erlang distribution cookie in vm.args . This defaults to a randomly generated string. Generate a project without nerves_pack support by passing --no-nerves-pack . Examples mix nerves . new blinky Is equivalent to: mix nerves . new blinky -- module Blinky Generate a project that only supports Raspberry Pi 3 mix nerves . new blinky -- target rpi3 Generate a project that supports Raspberry Pi 3 and Raspberry Pi Zero mix nerves . new blinky -- target rpi3 -- target rpi0 Generate a project without nerves_pack mix nerves . new blinky -- no - nerves - pack","ref":"Mix.Tasks.Nerves.New.html","title":"Mix.Tasks.Nerves.New","type":"task"},{"doc":"","ref":"Mix.Nerves.IO.html","title":"Mix.Nerves.IO","type":"module"},{"doc":"","ref":"Mix.Nerves.IO.html#debug_info/3","title":"Mix.Nerves.IO.debug_info/3","type":"function"},{"doc":"","ref":"Mix.Nerves.IO.html#nerves_env_info/0","title":"Mix.Nerves.IO.nerves_env_info/0","type":"function"},{"doc":"","ref":"Mix.Nerves.IO.html#shell_info/3","title":"Mix.Nerves.IO.shell_info/3","type":"function"},{"doc":"","ref":"Mix.Nerves.IO.html#shell_warn/3","title":"Mix.Nerves.IO.shell_warn/3","type":"function"},{"doc":"Cleans dependencies and build artifacts Since this is a destructive action, cleaning of dependencies only occurs when one of the following are specified: dep1 dep2 - the names of Nerves dependencies to be cleaned, separated by spaces --all - cleans all Nerves dependencies","ref":"Mix.Tasks.Nerves.Clean.html","title":"Mix.Tasks.Nerves.Clean","type":"task"},{"doc":"","ref":"Mix.Tasks.Nerves.Deps.Get.html","title":"Mix.Tasks.Nerves.Deps.Get","type":"task"},{"doc":"","ref":"Mix.Tasks.Nerves.Env.html","title":"Mix.Tasks.Nerves.Env","type":"task"},{"doc":"","ref":"Mix.Tasks.Nerves.Loadpaths.html","title":"Mix.Tasks.Nerves.Loadpaths","type":"task"},{"doc":"","ref":"Mix.Tasks.Nerves.Precompile.html","title":"Mix.Tasks.Nerves.Precompile","type":"task"},{"doc":"Open a shell in a system's build directory. In order to make the experience as similar as possible, we attach to a Docker container on non-Linux platforms and run a sub-shell on Linux. Examples Configure the system for the current project's target: mix nerves . system . shell","ref":"Mix.Tasks.Nerves.System.Shell.html","title":"Mix.Tasks.Nerves.System.Shell","type":"task"},{"doc":"Nerves.Bootstrap is an Elixir archive that brings Nerves support to Elixir's Mix build tool and provides a new project generator, mix nerves.new . We recommend reading the Nerves Installation Guide for installing and using Nerves. Read on for details specific to Nerves.Bootstrap.","ref":"readme.html","title":"Nerves.Bootstrap","type":"extras"},{"doc":"The first time you use Nerves and whenever you update your Elixir installation, run the follow to install the official archive: mix archive.install hex nerves_bootstrap From then on, Nerves.Bootstrap checks for new versions and will let you know. To manually upgrade either run the above line or the following: mix local.nerves If you need to force a specific version, run: mix archive.install hex nerves_bootstrap 1.0.1","ref":"readme.html#installation","title":"Nerves.Bootstrap - Installation","type":"extras"},{"doc":"This section provides a high level overview of Mix tasks provided by Nerves.Bootstrap. For additional details, run mix help task . mix nerves.new A mix task for creating new Nerves projects. mix nerves.new my_project The generated project will support compilation for all of the officially supported Nerves devices. Just like the Elixir new project generator, nerves.new supports many options to tweak the output. Generated projects will boot and provide an IEx prompt over the default console for the device. Here's a script for creating a new project and building it for a Raspberry Pi 3: mix nerves.new my_project cd my_project # Set MIX_TARGET to select Raspberry Pi 3-specific dependencies in the mix.exs export MIX_TARGET=rpi3 # Download dependencies, build firmware and write it to a MicroSD card mix deps.get mix firmware mix burn Generated projects include NervesPack in their dependency list. NervesPack depends on most of the Nerves-specific libraries that you'll need at the beginning of your project. This includes those needed for networking, firmware updates, and various helpful utilities. If you want a minimal project that does not include NervesPack, pass --no-nerves-pack : mix nerves.new my_new_nerves_project --no-nerves-pack mix local.nerves This task checks hex.pm for updates to the nerves_bootstrap archive. If one exists, you'll be prompted to update.","ref":"readme.html#mix-tasks","title":"Nerves.Bootstrap - Mix tasks","type":"extras"},{"doc":"Nerves.Bootstrap injects Nerves-specific build tasks into the mix build process via an Application.start/1 call in your project's config.exs . If you use mix nerves.new , your project will be created with these lines and no additional work is needed. # config/config.exs import Config Application . start ( :nerves_bootstrap )","ref":"readme.html#integration-with-your-project","title":"Nerves.Bootstrap - Integration with your project","type":"extras"},{"doc":"Nerves.Bootstrap uses Mix aliases to hook into Mix build steps. Aliases vary based on whether you are compiling for your host or your target device. For host builds, Nerves.Bootstrap injects the following tasks to add support for downloading pre-compiled archives. [ &quot;deps.get&quot; : [ &quot;deps.get&quot; , &quot;nerves.bootstrap&quot; , &quot;nerves.deps.get&quot; ] , &quot;deps.update&quot; : [ &quot;deps.update&quot; , &quot;nerves.bootstrap&quot; , &quot;nerves.deps.get&quot; ] ] When MIX_TARGET is set, Nerves.Bootstrap injects the following additional tasks to support cross-compilation and firmware creation: [ &quot;deps.loadpaths&quot; : [ &quot;nerves.bootstrap&quot; , &quot;nerves.loadpaths&quot; , &quot;deps.loadpaths&quot; ] , &quot;deps.compile&quot; : [ &quot;nerves.bootstrap&quot; , &quot;nerves.loadpaths&quot; , &quot;deps.compile&quot; ] , # This is just helper to prevent trying to run tasks on host that were # compiled for a target run : [ Nerves.Bootstrap.Aliases . run / 1 ] ] Nerves.Bootstrap provides only minimal code to inject the Nerves tooling. The main Nerves tooling is the Nerves library.","ref":"readme.html#internals","title":"Nerves.Bootstrap - Internals","type":"extras"},{"doc":"If you need to modify Nerves.Bootstrap, here's what you should do to get the source code, build it and install your changes locally: git clone https://github.com/nerves-project/nerves_bootstrap.git cd nerves_bootstrap mix do deps.get, archive.build, archive.install","ref":"readme.html#local-development","title":"Nerves.Bootstrap - Local development","type":"extras"},{"doc":"Copyright (C) 2017-22 Nerves Project Authors Licensed under the Apache License , Version 2.0 ( the &quot;License&quot; ) ; you may not use this file except in compliance with the License . You may obtain a copy of the License at [ http :// www . apache . org / licenses / LICENSE - 2.0 ] ( http :// www . apache . org / l &gt; Unless required by applicable law or agreed to in writing , software distributed under the License is distributed on an &quot;AS IS&quot; BASIS , WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND , either express or implied . See the License for the specific language governing permissions and limitations under the License .","ref":"readme.html#license","title":"Nerves.Bootstrap - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Updates Remove references to :build_embedded since that option is planned for removal in Elixir 1.15 and it wasn't needed.","ref":"changelog.html#1-11-2-2022-09-11","title":"Changelog - 1.11.2 - 2022-09-11","type":"extras"},{"doc":"Fixes Fixed backwards compatibility issue with building Nerves systems with Nerves 1.7.x.","ref":"changelog.html#1-11-1-2022-07-07","title":"Changelog - 1.11.1 - 2022-07-07","type":"extras"},{"doc":"Potentially breaking changes Elixir 1.11 or later is now required Move the core mix tooling to :nerves This is part of a bigger reorganization and adjustment to the bootstrap tooling in order to reduce it's footprint. However, these changes have been tested and are considered backwards compatible and most should not see any impact from it. If you were using Nerves.Bootstrap.Aliases module directly, you may notice adjusted aliases listed. Enhancements Add GRiSP2 to officially supported Nerves devices Improve message when unknown target is selected Add --no-nerves-pack to nerves.new options doc New project generator updates Remove system_registry option from generator toolshed 0.2.26 shoehorn 0.9.1 nerves_runtime 0.13.0 ring_logger 0.8.5","ref":"changelog.html#1-11-0-2022-07-06","title":"Changelog - 1.11.0 - 2022-07-06","type":"extras"},{"doc":"New project generator updates Update deprecated config option to MDNSLite Update references to mix burn in new project comments Update dependency versions to latest","ref":"changelog.html#1-10-6-2022-02-23","title":"Changelog - 1.10.6 - 2022-02-23","type":"extras"},{"doc":"New project generator updates Remove old reference to Mix.Config.","ref":"changelog.html#1-10-5","title":"Changelog - 1.10.5","type":"extras"},{"doc":"New project generator updates Update dependency versions to latest","ref":"changelog.html#1-10-4","title":"Changelog - 1.10.4","type":"extras"},{"doc":"New project generator updates Update dependency versions to latest Add NervesMOTD to the iex.exs Add more comments to commonly edited locations in the mix.exs","ref":"changelog.html#1-10-3","title":"Changelog - 1.10.3","type":"extras"},{"doc":"New project generator updates Strip everything but docs with MIX_ENV=dev Since most users don't use debug symbols, strip them out of the beams even for dev builds. This keeps docs, though. Here's are some firmware sizes to see the effect: circuits_quickstart_unstripped.fw 43597619 circuits_quickstart_docs.fw 33595640 circuits_quickstart_stripped.fw 33016963 As you can see, this saves ~10 MB and retains docs.","ref":"changelog.html#1-10-2","title":"Changelog - 1.10.2","type":"extras"},{"doc":"New project generator updates Add config/host.exs so that there's a more obvious location for host-only configuration Add rootfs_overlay/etc/iex.exs to the list of files to format with mix format","ref":"changelog.html#1-10-1","title":"Changelog - 1.10.1","type":"extras"},{"doc":"New project generator updates Added osd32mp1 to default targets in new project generator. See nerves_system_osd32mp1 for system information. Update formatting to more closely match Elixir 1.11's new project generator Simplify the Nerves/Mix integration (now only an update to config.exs ) Bump Nerves to ~&gt; 1.7.0 Bump Shoehorn to ~&gt; 0.7.0 Disable busy waiting in the BEAM by default.","ref":"changelog.html#1-10-0","title":"Changelog - 1.10.0","type":"extras"},{"doc":"New project generator updates Bump NervesPack to 0.4 which drops :nerves_firwmare_ssh in favor of :nerves_ssh and :ssh_subsystem_fwup for access and updates. Bump Nerves to ~&gt; 1.6.3 Bump NervesRuntime to ~&gt; 0.11.3 Bump RingLogger to ~&gt; 0.8.1","ref":"changelog.html#1-9-0","title":"Changelog - 1.9.0","type":"extras"},{"doc":"New project generator updates Update systems to latest versions. Add an example for overriding erlinit options using Mix config.","ref":"changelog.html#1-8-1","title":"Changelog - 1.8.1","type":"extras"},{"doc":"New project generator updates Bump Nerves to 1.6 and update systems. Default to use --nerves-pack . Remove options for --init-gadget .","ref":"changelog.html#1-8-0","title":"Changelog - 1.8.0","type":"extras"},{"doc":"Enhancements Updated Elixir 1.10 deprecated function calls.","ref":"changelog.html#1-7-1","title":"Changelog - 1.7.1","type":"extras"},{"doc":"Enhancements Improved support for reproducible builds in new projects by setting source_date_epoch . Existing projects can add this to the :nerves config. For example: config :nerves , source_date_epoch : &quot;1577467691&quot; Added support for generating new projects using nerves_pack instead of nerves_init_gadget . See nerves_pack for more information. For example: mix nerves.new my_app --nerves-pack","ref":"changelog.html#1-7-0","title":"Changelog - 1.7.0","type":"extras"},{"doc":"Enhancements Don't allow projects to be named nerves . Those won't work anyway.","ref":"changelog.html#1-6-3","title":"Changelog - 1.6.3","type":"extras"},{"doc":"Enhancements Synchronize new project files to better match the versions from mix new","ref":"changelog.html#1-6-2","title":"Changelog - 1.6.2","type":"extras"},{"doc":"Enhancements Added rpi4 to default targets in new project generator. See nerves_system_rpi4 for system information. Update release config to only strip beams for :prod firmware. Bug fixes Fix --cookie in new project generator for overriding the cookie.","ref":"changelog.html#1-6-1","title":"Changelog - 1.6.1","type":"extras"},{"doc":"Enhancements Updated new project generator to use Elixir ~&gt; 1.9","ref":"changelog.html#1-6-0","title":"Changelog - 1.6.0","type":"extras"},{"doc":"Bug fixes Change distillery to ~&gt; 2.0 in the new project generator.","ref":"changelog.html#1-5-3","title":"Changelog - 1.5.3","type":"extras"},{"doc":"Bug fixes Add distillery ~&gt; 2.1 to the new project generator. Lock down the nerves dependency to ~&gt; 1.4.5 in new projects.","ref":"changelog.html#1-5-2","title":"Changelog - 1.5.2","type":"extras"},{"doc":"Bug fixes Compile distillery before nerves when included as an optional dependency.","ref":"changelog.html#1-5-1","title":"Changelog - 1.5.1","type":"extras"},{"doc":"Enhancements New projects include nerves_init_gadget by default. If you want a minimal project that does not include nerves_init_gadget , pass --no-init-gadget .","ref":"changelog.html#1-5-0","title":"Changelog - 1.5.0","type":"extras"},{"doc":"Enhancements Create mix.exs files with build_embedded: true so that build products aren't stored in the source tree. This helps fix a source of confusion when switching targets and C/C++ build products don't get rebuilt. Improve the missing ssh key error message in config.exs","ref":"changelog.html#1-4-3","title":"Changelog - 1.4.3","type":"extras"},{"doc":"Enhancements Added rpi3a to default supported targets list. See nerves_system_rpi3a . Bumped the minimum versions from 1.5 to 1.6. Improved error message when trying to create new projects that support Elixir ~&gt; 1.8 while running a version that is &lt; 1.8. Set required bootstrap archive version to ~&gt; major.minor of the version of nerves_bootstrap that generated the new project.","ref":"changelog.html#1-4-2","title":"Changelog - 1.4.2","type":"extras"},{"doc":"Bug fixes Configure nerves_bootstrap to support Elixir ~&gt; 1.7. Use ~&gt; 1.8 for new projects.","ref":"changelog.html#1-4-1","title":"Changelog - 1.4.1","type":"extras"},{"doc":"Version v1.4.0 adds support for Elixir 1.8's new built-in support for mix targets. In Nerves, the MIX_TARGET was used to select the appropriate set of dependencies for a device. This lets you switch between building for different boards and your host. Elixir 1.8 pulls this support into mix and lets you annotate dependencies for which targets they should be used. See the project update guide to learn how to migrate your project. Enhancements New projects are generated for Elixir 1.8. Support non-RSA SSH keys in new projects.","ref":"changelog.html#1-4-0","title":"Changelog - 1.4.0","type":"extras"},{"doc":"New project generator fixes Enable multi_time_warp mode by default. This fixes an issue where the Erlang system clock wouldn't get updated after the clock was set.","ref":"changelog.html#1-3-4","title":"Changelog - 1.3.4","type":"extras"},{"doc":"New project generator enhancements Update ring_logger to ~&gt; 0.6 . Add toolshed ~&gt; 0.2 and update rootfs_overlay/etc/iex.exs Enable Erlang Distribution when Mix.env() != :prod Remove ev3 from default supported target list Update bbb system version requirement to ~&gt; 2.0 Update all other system version requirements to ~&gt; 1.5","ref":"changelog.html#1-3-3","title":"Changelog - 1.3.3","type":"extras"},{"doc":"Enhancements Updated docs for mix nerves.new . Bug fixes Invoke Nerves environment when calling deps.compile . Display warning instead of raising when calling mix run .","ref":"changelog.html#1-3-2","title":"Changelog - 1.3.2","type":"extras"},{"doc":"Enhancements Use :dhcpd instead of :linklocal for nerves_init_gadget defaults.","ref":"changelog.html#1-3-1","title":"Changelog - 1.3.1","type":"extras"},{"doc":"New features Enable heart in the new project generator. This engages both a software-based watchdog (Erlang's heart feature) and a hardware-based one on systems that support it. If the Erlang VM becomes unresponsive, one of the watchdogs will reboot the processor. See the Erlang heart documentation for changing timeouts and adding callbacks to your application. Enable build_embedded . This ensures that C build products are separated based on target and prevents many causes of x86 build products ending up on ARM targets unintentionally.","ref":"changelog.html#1-3-0","title":"Changelog - 1.3.0","type":"extras"},{"doc":"Bug fixes Add RingLogger to all deps in new project generator. This fixes an issue that causes new projects generated with --init-gadget to crash on boot running on the host.","ref":"changelog.html#1-2-1","title":"Changelog - 1.2.1","type":"extras"},{"doc":"Add support for generating new projects with nerves_init_gadget . To generate a new project with nerves_init_gadget included, pass --init-gadget to mix nerves.new For example: mix nerves.new my_app --init-gadget","ref":"changelog.html#1-2-0","title":"Changelog - 1.2.0","type":"extras"},{"doc":"This release updates the new project generator to create projects that will work with Elixir 1.7 and Distillery 2.0. Enhancements Update new project generator to support shoehorn v0.4. Bump minimum deps to latest versions.","ref":"changelog.html#1-1-0","title":"Changelog - 1.1.0","type":"extras"},{"doc":"Enhancements Update new project generator to target 1.0 systems","ref":"changelog.html#v1-0-1","title":"Changelog - v1.0.1","type":"extras"},{"doc":"Bug Fixes Rename provider to build_runner . Fixes issues with running mix nerves.system.shell and mix nerves.env --info","ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras"},{"doc":"Updates New project generator no longer conditionally defines application/0 in mix.exs depending on target. It is recommended to conditionally choose the main supervisors children instead. New project generator moves the dependency shoehorn to be included for both host and target environments.","ref":"changelog.html#v1-0-0-rc-4","title":"Changelog - v1.0.0-rc.4","type":"extras"},{"doc":"Updates Various new project generator code format updates. Include :runtime_tools in :extra_applications . Bug fixes Only display Nerves environment helper text when the Nerves environment is loaded. Fixes issues with running mix commands like mix format - that require the I/O to remain clean.","ref":"changelog.html#v1-0-0-rc-3","title":"Changelog - v1.0.0-rc.3","type":"extras"},{"doc":"Updates Remove build_embedded from the mix.exs since it was unnecessary Fix update check in mix local.nerves Various changes to align new project generator with the one in Elixir 1.6. Add rootfs_overlay directory and populate it with an iex.exs to load the nerves_runtime IEX helpers. This replaces a common manual process of doing this or something similar afterwards. Add a commented out reference for enabling Erlang's heartbeat monitor","ref":"changelog.html#v1-0-0-rc-2","title":"Changelog - v1.0.0-rc.2","type":"extras"},{"doc":"Bug fixes Various mix format updates to the template Update template so that projects use v1.0.0-rc system releases so that they compile Fix archive update check logic","ref":"changelog.html#v1-0-0-rc-1","title":"Changelog - v1.0.0-rc.1","type":"extras"},{"doc":"Nerves no longer automatically compiles any nerves_package that is missing it's pre-compiled artifact. This turned out to rarely be desired and caused unexpectedly long compilation times when things like the Linux kernel or gcc got compiled. When a pre-compiled artifact is missing, Nerves will now tell you what your options are to resolve this. It could be retrying mix deps.get to download it again. If you want to force compilation to happen, add a :nerves option for the desired package in your top level project: { :nerves_system_rpi0 , &quot;~&gt; 1.0-rc&quot; , nerves : [ compile : true ] }","ref":"changelog.html#v1-0-0-rc-0","title":"Changelog - v1.0.0-rc.0","type":"extras"},{"doc":"Bug Fixes deps.get and deps.update aliases should always be added to the project regardless of target.","ref":"changelog.html#v0-8-1","title":"Changelog - v0.8.1","type":"extras"},{"doc":"The v0.7.x and earlier releases only required two aliases in your mix.exs to pull in the Nerves enhancements to mix.exs . This releases adds more aliases. Rather than requiring your mix.exs file to be updated if the Nerves alias hooks change in the future, we recommend updating your mix.exs as follows: # mix.exs def project do [ # ... aliases : [ &quot;loadconfig&quot; : [ &amp; bootstrap / 1 ] ] , ] end # Starting nerves_bootstrap pulls in the Nerves hooks to mix, but only # if the MIX_TARGET environment variable is set. defp bootstrap ( args ) do Application . start ( :nerves_bootstrap ) Mix.Task . run ( &quot;loadconfig&quot; , args ) end This release has the following changes: Enhancements precompile will compile all Nerves packages instead of only the system and its children. Calling run while MIX_TARGET is set will raise an exception for trying to run cross compiled code on the host. Application.start(:nerves_bootstrap) will attempt to add aliases to the mix project on the top of the stack if MIX_TARGET is set.","ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","type":"extras"},{"doc":"Enhancements Added alias for deps.update to append nerves.deps.get to fetch artifacts.","ref":"changelog.html#v0-7-1","title":"Changelog - v0.7.1","type":"extras"},{"doc":"Enhancements Added Mix task nerves.deps.get nerves_bootstrap will check for updates when nerves.deps.get is called. Added Nerves.Bootstrap.add_aliases/1 This helper function ensures that your project has the required Nerves mix aliases defined and in the correct execution order. The function takes the existing aliases as a keyword list and injects the required Nerves aliases. You will need to update your mix.exs target aliases to use this version of nerves_bootstrap like this: defp aliases ( _target ) do [ # Add custom mix aliases here ] |&gt; Nerves.Bootstrap . add_aliases ( ) end You should also update your required dependency for nerves to {:nerves, &quot;~&gt; 0.9&quot;, runtime: false} Bug Fixes disable precompiler when calling mix nerves.clean to prevent having to build the package so we can clean it. Fixes issue where project dependencies that contain calls to System.get_env in their config or mix file or rebar deps that have rebar-config.script overrides that make os:getenv calls were not being configured for the cross compile environment.","ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras"},{"doc":"Enhancements Changed update location from Github to hex.pm Fixed compiler warning Synchronize new project template with Elixir 1.6 updates (includes formatter)","ref":"changelog.html#v0-6-4","title":"Changelog - v0.6.4","type":"extras"},{"doc":"Enhancements Removed unsupported systems from default targets and added x86_64. Moved to independent hex package.","ref":"changelog.html#v0-6-3","title":"Changelog - v0.6.3","type":"extras"},{"doc":"Enhancements [mix nerves.new] Use the new rootfs_overlay option rather than the deprecated rootfs_additions option and also recommend placing the relevant files in a top-level rootfs_overlay directory in the project root rather than in config/rootfs_additions . [mix nerves.new] system dependencies are appended as a list so there is a clear location for where system specific dependencies are added. [mix nerves.new] moved the config for bootloader above so that it is configured before importing target specific configuration.","ref":"changelog.html#v0-6-2","title":"Changelog - v0.6.2","type":"extras"},{"doc":"Enhancements Improved error messages in nerves.system.shell Mix task. In particular, it now reminds you to set MIX_TARGET . Bug Fixes The nerves.env Mix task (used internally by Nerves) now checks that your deps have been fetched before trying to load. Fix extraneous whitespace in mix.exs generated by mix nerves.new","ref":"changelog.html#v0-6-1","title":"Changelog - v0.6.1","type":"extras"},{"doc":"Enhancements New nerves.system.shell Mix task, which provides a consistent way to configure a Buildroot-based Nerves system on both OSX and Linux. This replaces the nerves.shell Mix task that was provided by the nerves dependency, which had not been fully implemented. Add an optional --disabled flag to the nerves.env Mix task, which allows the Nerves environment to be compiled and loaded in a disabled state so that it doesn't try to actually cross-compile all the dependencies at load time. This is primarily used so that Mix tasks like nerves.system.shell can run on the host without having to wait for dependencies to compile when they won't even be used. Related to the previous change, the nerves.precompile task does not try to compile the toolchain and system when Nerves.Env is loaded in a disabled state.","ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","type":"extras"},{"doc":"Bug Fixes System dependencies were not being built in order when system is the parent project","ref":"changelog.html#v0-5-1","title":"Changelog - v0.5.1","type":"extras"},{"doc":"Enhancements Pass +Bc in vm.args to avoid accidental CTRL+C Update deps and loosen version requirements Include bootloader in new projects Bug Fixes Choose the right compiler when parent project is a Nerves system package","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"},{"doc":"Enhancements nerves.new lock files are split by target Target dependencies are explicitly broken out in mix.exs through passing --target to the generator. Defaults to declaring all officially supported Nerves Targets. A default cookie is generated and placed in the vm.args. the cookie can be set by passing --cookie","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"Bug Fixes Added support for OTP 20: Fixes issue with RegEx producing false positives.","ref":"changelog.html#v0-3-1","title":"Changelog - v0.3.1","type":"extras"},{"doc":"Enhancements nerves.new defaults to Host target env includes nerves_runtime prompt to install deps and run nerves.release.init unset MIX_TARGET when generating a new project Bug Fixes removed rel/.gitignore from new project generator","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"Enhancements Added mix local.nerves for updating the bootstrap archive","ref":"changelog.html#v0-2-2","title":"Changelog - v0.2.2","type":"extras"},{"doc":"Bug Fixes update nerves dep in new project generator to 0.4.0 Enhancements Additional debug output when setting NERVES_DEBUG=1 Ability to output information about the loaded Nerves env via mix nerves.env --info","ref":"changelog.html#v0-2-1","title":"Changelog - v0.2.1","type":"extras"},{"doc":"Enhancements Support for nerves_package compiler","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Bug Fixes Do not warn on import Supervisor.Spec Silence alias location messages unless NERVES_DEBUG=1 Enhancements Support for Elixir 1.3.2","ref":"changelog.html#v0-1-4","title":"Changelog - v0.1.4","type":"extras"},{"doc":"Enhancements Support for elixir ~&gt; 1.3.0-rc.0","ref":"changelog.html#v0-1-3","title":"Changelog - v0.1.3","type":"extras"}]